// content/browser/tracing/trace_report/trace_report.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "content/browser/tracing/trace_report/trace_report.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "content/browser/tracing/trace_report/trace_report.mojom-params-data.h"
namespace trace_report {
namespace mojom {

NOINLINE static const char* ReportUploadStateToStringHelper(ReportUploadState value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ReportUploadState::kNotUploaded:
      return "kNotUploaded";
    case ReportUploadState::kPending:
      return "kPending";
    case ReportUploadState::kPending_UserRequested:
      return "kPending_UserRequested";
    case ReportUploadState::kUploaded:
      return "kUploaded";
    default:
      return nullptr;
  }
}

std::string ReportUploadStateToString(ReportUploadState value) {
  const char *str = ReportUploadStateToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ReportUploadState value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ReportUploadState value) {
  return os << ReportUploadStateToString(value);
}

NOINLINE static const char* SkipUploadReasonToStringHelper(SkipUploadReason value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case SkipUploadReason::kNoSkip:
      return "kNoSkip";
    case SkipUploadReason::kSizeLimitExceeded:
      return "kSizeLimitExceeded";
    case SkipUploadReason::kNotAnonymized:
      return "kNotAnonymized";
    case SkipUploadReason::kScenarioQuotaExceeded:
      return "kScenarioQuotaExceeded";
    case SkipUploadReason::kUploadTimedOut:
      return "kUploadTimedOut";
    default:
      return nullptr;
  }
}

std::string SkipUploadReasonToString(SkipUploadReason value) {
  const char *str = SkipUploadReasonToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown SkipUploadReason value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, SkipUploadReason value) {
  return os << SkipUploadReasonToString(value);
}

namespace internal {


// static
bool ClientTraceReport_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 64, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ClientTraceReport_Data* object =
      static_cast<const ClientTraceReport_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->uuid, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->uuid, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->creation_time, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->creation_time, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->scenario_name, 3, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& scenario_name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->scenario_name, validation_context,
                                         &scenario_name_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->upload_rule_name, 4, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& upload_rule_name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->upload_rule_name, validation_context,
                                         &upload_rule_name_validate_params)) {
    return false;
  }


  if (!::trace_report::mojom::internal::ReportUploadState_Data
        ::Validate(object->upload_state, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->upload_time, 7, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->upload_time, validation_context))
    return false;


  if (!::trace_report::mojom::internal::SkipUploadReason_Data
        ::Validate(object->skip_reason, validation_context))
    return false;

  return true;
}

ClientTraceReport_Data::ClientTraceReport_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool TraceReportHandlerFactory_CreatePageHandler_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const TraceReportHandlerFactory_CreatePageHandler_Params_Data* object =
      static_cast<const TraceReportHandlerFactory_CreatePageHandler_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->page, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->page,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->handler, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->handler,
                                                 validation_context)) {
    return false;
  }

  return true;
}

TraceReportHandlerFactory_CreatePageHandler_Params_Data::TraceReportHandlerFactory_CreatePageHandler_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_GetAllTraceReports_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_GetAllTraceReports_Params_Data* object =
      static_cast<const PageHandler_GetAllTraceReports_Params_Data*>(data);

  return true;
}

PageHandler_GetAllTraceReports_Params_Data::PageHandler_GetAllTraceReports_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_GetAllTraceReports_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_GetAllTraceReports_ResponseParams_Data* object =
      static_cast<const PageHandler_GetAllTraceReports_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->reports, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& reports_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->reports, validation_context,
                                         &reports_validate_params)) {
    return false;
  }

  return true;
}

PageHandler_GetAllTraceReports_ResponseParams_Data::PageHandler_GetAllTraceReports_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_DeleteSingleTrace_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_DeleteSingleTrace_Params_Data* object =
      static_cast<const PageHandler_DeleteSingleTrace_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->uuid, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->uuid, validation_context))
    return false;

  return true;
}

PageHandler_DeleteSingleTrace_Params_Data::PageHandler_DeleteSingleTrace_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_DeleteSingleTrace_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_DeleteSingleTrace_ResponseParams_Data* object =
      static_cast<const PageHandler_DeleteSingleTrace_ResponseParams_Data*>(data);

  return true;
}

PageHandler_DeleteSingleTrace_ResponseParams_Data::PageHandler_DeleteSingleTrace_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_DeleteAllTraces_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_DeleteAllTraces_Params_Data* object =
      static_cast<const PageHandler_DeleteAllTraces_Params_Data*>(data);

  return true;
}

PageHandler_DeleteAllTraces_Params_Data::PageHandler_DeleteAllTraces_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_DeleteAllTraces_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_DeleteAllTraces_ResponseParams_Data* object =
      static_cast<const PageHandler_DeleteAllTraces_ResponseParams_Data*>(data);

  return true;
}

PageHandler_DeleteAllTraces_ResponseParams_Data::PageHandler_DeleteAllTraces_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_UserUploadSingleTrace_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_UserUploadSingleTrace_Params_Data* object =
      static_cast<const PageHandler_UserUploadSingleTrace_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->uuid, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->uuid, validation_context))
    return false;

  return true;
}

PageHandler_UserUploadSingleTrace_Params_Data::PageHandler_UserUploadSingleTrace_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_UserUploadSingleTrace_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_UserUploadSingleTrace_ResponseParams_Data* object =
      static_cast<const PageHandler_UserUploadSingleTrace_ResponseParams_Data*>(data);

  return true;
}

PageHandler_UserUploadSingleTrace_ResponseParams_Data::PageHandler_UserUploadSingleTrace_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_DownloadTrace_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_DownloadTrace_Params_Data* object =
      static_cast<const PageHandler_DownloadTrace_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->uuid, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->uuid, validation_context))
    return false;

  return true;
}

PageHandler_DownloadTrace_Params_Data::PageHandler_DownloadTrace_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool PageHandler_DownloadTrace_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const PageHandler_DownloadTrace_ResponseParams_Data* object =
      static_cast<const PageHandler_DownloadTrace_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnion(object->trace, validation_context))
    return false;

  return true;
}

PageHandler_DownloadTrace_ResponseParams_Data::PageHandler_DownloadTrace_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace trace_report

namespace perfetto {

// static
void TraceFormatTraits<::trace_report::mojom::ReportUploadState>::WriteIntoTrace(
   perfetto::TracedValue context, ::trace_report::mojom::ReportUploadState value) {
  return std::move(context).WriteString(::trace_report::mojom::ReportUploadStateToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::trace_report::mojom::SkipUploadReason>::WriteIntoTrace(
   perfetto::TracedValue context, ::trace_report::mojom::SkipUploadReason value) {
  return std::move(context).WriteString(::trace_report::mojom::SkipUploadReasonToString(value));
}

} // namespace perfetto